package me.Demon.DemonCropBuyShop.listener;

import me.Demon.DemonCropBuyShop.CropData;
import me.Demon.DemonCropBuyShop.Event.PlayerCropBuyEvent;
import me.Demon.DemonCropBuyShop.Main;
import me.Demon.DemonPlugin.DemonAPI;
import me.skymc.taboomenu.TabooMenuAPI;
import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.Sound;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.inventory.ClickType;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;

import java.text.DecimalFormat;

public class GuiListener implements Listener {

    @EventHandler
    public void onclick(InventoryClickEvent e){
        Player p = (Player) e.getWhoClicked();
        if(e.getInventory().getHolder() != null && e.getInventory().getHolder() instanceof BuyGui){
            e.setCancelled(true);
            int rawSlot = e.getRawSlot();
            if(rawSlot <= 0 || rawSlot >= e.getInventory().getSize()){
                return;
            }
            if(rawSlot == 31){
                TabooMenuAPI.openMenu(p,"商城菜单",true);
                return;
            }
            if(Main.itemIsNull(e.getCurrentItem()) && Main.itemIsLore(e.getCurrentItem())){
                return;
            }
            String CorpType = e.getCurrentItem().getType().name();
            if (e.getClick() == ClickType.LEFT) {
                if(e.getCurrentItem().getType() == Material.EGG) {
                    SellItemsEvant(p,CorpType, 16, 1);
                } else {
                    SellItemsEvant(p, CorpType, 64, 1);
                }
            }
            if (e.getClick() == ClickType.RIGHT) {
                if(e.getCurrentItem().getType() == Material.EGG) {
                    SellItemsEvant(p, CorpType, 16*27, 2);
                }else{
                    SellItemsEvant(p, CorpType, 1728, 2);
                }
            }
        }
    }

    public static void SellItemsEvant(Player p, String CropType, int sellAmount, int type){
        if(Main.TodayBank >= 30000000){
            p.sendMessage(Main.prefix+"农贸市场每日仅回收3000万金币的农作物.");
            p.playSound(p.getLocation(), Sound.ENTITY_VILLAGER_NO, 1, 2);
            return;
        }
        CropData dataAPI = Main.dataAPI.get(CropType);
        //检测玩家是否拥有这么多的物品出售
        ItemStack item = dataAPI.getItem();
        int PlayerAmount = getInvAmount(p,item);
        if(PlayerAmount < sellAmount){
            p.sendMessage(Main.prefix+"你没有足够的物品.");
            p.playSound(p.getLocation(), Sound.ENTITY_VILLAGER_NO, 1, 2);
            return;
        }
        SellItemEvent(p.getInventory(),PlayerAmount,item,sellAmount);
        int price = (int) dataAPI.getMoney();
        if(type == 2){
            price = price * 27;
        }
        double tax = 0.05;
        if(p.hasPermission("vip2.use")){
            tax = 0.02;
        }else if(p.hasPermission("vip1.use")){
            tax = 0.03;
        }
        price = (int) (price - (price * tax));
        double taxMoney = price * tax;
        DemonAPI.giveMoney(p, price);
        Main.TodayBank = Main.TodayBank + price;
        p.sendMessage(Main.prefix + "你获得了: §f$" + new DecimalFormat(",###.##").format(price) + "金币 §6(纳税: " + new DecimalFormat("#.##").format(taxMoney) + "金币)");
        p.updateInventory();
        p.playSound(p.getLocation(), Sound.BLOCK_COMPARATOR_CLICK, 1, 2);
        PlayerCropBuyEvent event = new PlayerCropBuyEvent(p, dataAPI.getCropType(), sellAmount,price,(int) taxMoney);
        Bukkit.getPluginManager().callEvent(event);
        new BuyGui(p);
    }

    public static int getInvAmount(Player p, ItemStack item){
        int amount = 0;
        Inventory inv = p.getInventory();
        Material material = item.getType();
        for (int i = 0;i < 36;i++){
            ItemStack items = inv.getItem(i);
            if(!Main.itemIsNull(items) && Main.itemIsLore(items)){
                Material inv_type = items.getType();
                if(inv_type == material){
                    amount = amount + items.getAmount();
                }
            }
        }
        return amount;
    }
    public static void SellItemEvent(Inventory inv,int playerAmount,ItemStack item,int sellAmount){
        int last = playerAmount - sellAmount;
        for (int i = 0;i < 36;i++){
            ItemStack items = inv.getItem(i);
            if(!Main.itemIsNull(items) && Main.itemIsLore(items)){
                Material inv_type = items.getType();
                if(inv_type == item.getType()){
                    inv.setItem(i, new ItemStack(Material.AIR));
                }
            }
        }
        if(last >= 1) {
            ItemStack newItem = new ItemStack(item.getType());
            newItem.setAmount(last);
            inv.addItem(newItem);
        }
    }
}
